#TEMPLATE(PierreT, 'Pierre T. Utilities and Goodies'),FAMILY('ABC')
#CONTROL(SliderControl,'Slider Control (trackbar) 32bit'),DESCRIPTION('Slider Control (trackbar) 32bit ' & %ActiveTemplateInstance),WINDOW,MULTI
#BOXED('Hidden Prompts'), AT(0,0,0,0), WHERE(%False), HIDE
#INSERT(%OOPHiddenPrompts(ABC))
#ENDBOXED


#PREPARE
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassItem(ABC),'cTrack'&%ActiveTemplateInstance)
  #CALL(%SetOOPDefaults(ABC), 'cTrack'&%ActiveTemplateInstance,'cTrackbar')
#ENDPREPARE

   CONTROLS
     REGION,AT(,,165,25),USE(?Region1)
   END

#ATSTART
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassItem(ABC), 'cTrack' & %ActiveTemplateInstance)
  #CALL(%SetOOPDefaults(ABC), 'cTrack' & %ActiveTemplateInstance, 'cTrackbar')
  #IF(%Target32 <> 1)
    #ERROR('Application must be compiled in 32 bit to use the control')
  #ENDIF
  #! #ADD(%ModuleIncludeList, 'trackbar.inc')
  #DECLARE(%ptSliderStyleStr)
  #DECLARE(%ptSliderStyleExStr)
  #DECLARE(%ptSliderSetLimitLower)
  #DECLARE(%ptSliderSetLimitUpper)
  #DECLARE(%ptSliderSetRangeStart)
  #DECLARE(%ptSliderSetRangeEnd)
#ENDAT

#SHEET
  #TAB('General')
    #PROMPT('Object Name: ', @s10), %ptSliderObject, DEFAULT('cTrack'&%ActiveTemplateInstance)
    #PROMPT('Slider variable: ', FIELD), %ptSliderPos
    #PROMPT('Position Slider with current value', CHECK),%ptSetSliderPosition, AT(10)
    #PROMPT('Oriention: ', DROP('Horizontal|Vertical')), %ptSliderOrientation
    #BOXED, SECTION
      #BOXED('Ticks location'), WHERE(%ptSliderOrientation = 'Horizontal'), AT(,0)
        #PROMPT('Ticks are: ' , DROP('Both|Bottom|Top')), %ptThumbPoint, DEFAULT('Bottom')
      #ENDBOXED
      #BOXED('Ticks location'), WHERE(%ptSliderOrientation = 'Vertical'), AT(,0)
        #PROMPT('Ticks are: ' , DROP('Both|Left|Right')), %ptThumbPoint, DEFAULT('Left')
      #ENDBOXED
    #ENDBOXED
    #BOXED('Page Size')
      #PROMPT('Page Size is a: ', DROP('Constant|Variable')), %ptSliderPageType, DEFAULT('Constant')
      #BOXED, SECTION
        #BOXED('Constant Value'), WHERE(%ptSliderPageType = 'Constant'), AT(,0)
          #PROMPT('Page size: ', @n3), %ptSliderPageConst, DEFAULT(10)
        #ENDBOXED
        #BOXED('Variable'), WHERE(%ptSliderPageType = 'Variable'), AT(,0)
          #PROMPT('Page Size: ', FIELD), %ptSliderPage
        #ENDBOXED
      #ENDBOXED
    #ENDBOXED
    #BOXED('Limit Boundary')
      #PROMPT('Lower limit is a: ', DROP('Constant|Variable')), %ptSliderLowerType, DEFAULT('Constant')
      #BOXED, SECTION
        #BOXED('Constant Value'), WHERE(%ptSliderLowerType = 'Constant'), AT(,0)
          #PROMPT('Lower limit:', @n-5), %ptSliderLowerConst, DEFAULT(1)
        #ENDBOXED
        #BOXED('Variable'), WHERE(%ptSliderLowerType = 'Variable') , AT(,0)
          #PROMPT('Lower limit: ', FIELD), %ptSliderLowerVar
        #ENDBOXED
      #ENDBOXED
      #PROMPT('Upper limit is a : ', DROP('Constant|Variable')), %ptSliderUpperType, DEFAULT('Constant')
      #BOXED, SECTION
        #BOXED('Constant Value'), WHERE(%ptSliderUpperType = 'Constant'), AT(,0)
          #PROMPT('Upper limit:', @n-5), %ptSliderUpperConst, DEFAULT(100)
        #ENDBOXED
        #BOXED('Variable'), WHERE(%ptSliderUpperType = 'Variable') , AT(,0)
          #PROMPT('Upper limit: ', FIELD), %ptSliderUpperVar
        #ENDBOXED
      #ENDBOXED
    #ENDBOXED
  #ENDTAB
  #TAB('Style')
    #PROMPT('Use ticks', CHECK), %ptSliderHasTick, DEFAULT(1), AT(10)
    #ENABLE(%ptSliderHasTick), CLEAR
      #BOXED('Ticks setting')
        #PROMPT('Auto ticks', CHECK), %ptAutoTick,  AT(10)
        #PROMPT('Ticks frequency: ', @n3), %ptTickFreq
      #ENDBOXED
    #ENDENABLE
    #PROMPT('No thumb' , CHECK), %ptNoThumb, DEFAULT(0), AT(10)
    #PROMPT('ToolTips ', CHECK), %ptToolTips, DEFAULT(0), AT(10)
    #PROMPT('Frame: ', DROP('No Frame|Static Edge|Client Edge')), %ptSliderFrame
    #PROMPT('Range selection', CHECK), %ptRangeSelection, DEFAULT(0), AT(10)
    #ENABLE(%ptRangeSelection), CLEAR
      #BOXED('Range')
        #PROMPT('Start position is a ', DROP('Constant|Variable')), %ptRangeStartType
        #BOXED, SECTION
          #BOXED('Constant Value'), WHERE(%ptRangeStartType = 'Constant'), AT(,0)
            #PROMPT('Start position:', @n-5), %ptRangeStartConst
          #ENDBOXED
          #BOXED('Variable'), WHERE(%ptRangeStartType = 'Variable') , AT(,0)
            #PROMPT('Start position: ', FIELD), %ptRangeStartVar
          #ENDBOXED
        #ENDBOXED
        #PROMPT('End position is a: ' , DROP('Constant|Variable')), %ptRangeEndType
        #BOXED, SECTION
          #BOXED('Constant Value'), WHERE(%ptRangeEndType = 'Constant'), AT(,0)
            #PROMPT('End position:', @n-5), %ptRangeEndConst
          #ENDBOXED
          #BOXED('Variable'), WHERE(%ptRangeEndType = 'Variable') , AT(,0)
            #PROMPT('End position: ', FIELD), %ptRangeEndVar
          #ENDBOXED
        #ENDBOXED
        #PROMPT('Limit thumb in range', CHECK), %ptThumbInRange, DEFAULT(0), AT(10)
      #ENDBOXED
    #ENDENABLE
  #ENDTAB
  #TAB('Class')
#!     #BUTTON('Classes...')
      #WITH(%ClassItem, 'cTrack' & %ActiveTemplateInstance)
        #INSERT(%ClassPrompts(ABC))
      #ENDWITH
#!     #ENDBUTTON
  #ENDTAB
#ENDSHEET

#AT(%GatherObjects)
#CALL(%SetClassItem(ABC),'cTrack' &%ActiveTemplateInstance)
#ADD(%ObjectList,'cTrack' & %ActiveTemplateInstance)
#SET(%ObjectListType,'cTrackbar')
#ENDAT

#AT(%LocalDataClasses)
  #CALL(%SetClassItem(ABC), 'cTrack' & %ActiveTemplateInstance)
#INSERT(%GenerateClassDefinition(ABC), %ClassLines)
#ENDAT

#AT(%ProcedureRoutines)
#! #CALL(%SetClassItem(ABC),'cTrack' & %ActiveTemplateInstance)
#CALL(%SetClassItem(ABC),'Default')
#IF(%BaseClassToUse())
  #CALL(%FixClassName(ABC),%BaseClassToUse())
  #FOR(%pClassMethod)
    #FOR(%pClassMethodPrototype),WHERE(%MethodEmbedPointValid())
      #CALL(%SetupMethodCheck(ABC))
#EMBED(%cTrackMethodDataSection,'Trackbar Method Data Section'), %activeTemplateInstance, %pClassMethod,%pClassMethodPrototype,LABEL,DATA,PREPARE(%FixClassName(%FixBaseClassToUse('Default'))),TREE(%GetEmbedTreeDesc('Trackbar Manager','DATA'))
  #?CODE
  #EMBED(%cTrackMethodCodeSection,'Trackbar Method Executable Code Section'), %activeTemplateInstance, %pClassMethod,%pClassMethodPrototype,PREPARE(%FixClassName(%FixBaseClassToUse('Default'))),TREE(%GetEmbedTreeDesc('Trackbar Manager','CODE'))
      #CALL(%CheckAddMethodPrototype(ABC),%ClassLines)
    #ENDFOR
  #ENDFOR
  #CALL(%GenerateNewLocalMethods(ABC),'Trackbar Manager')
#ENDIF
#ENDAT

#AT(%cTrackMethodCodeSection,%ActiveTemplateInstance), PRIORITY(5000),DESCRIPTION('Parent Call'),WHERE(%ParentCallValid())
  #CALL(%GenerateParentCall(ABC))
#END

#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'), PRIORITY(8030)
%ptSliderObject.m_Style = bor(WS_CHILD, bor(WS_VISIBLE, WS_TABSTOP))
  #SET(%ptSliderStyleStr, 'WS_CHILD + WS_VISIBLE + WS_TABSTOP')
  #IF(%ptAutoTick)
%ptSliderObject.m_Style = bor(%ptSliderObject.m_Style, TBS_AUTOTICKS)
    #SET(%ptSliderStyleStr, CLIP(%ptSliderStyleStr) & ' + TBS_AUTOTICKS')
  #ENDIF
  #IF(%ptNoThumb)
%ptSliderObject.m_Style = bor(%ptSliderObject.m_Style, TBS_NOTHUMB)
    #SET(%ptSliderStyleStr, CLIP(%ptSliderStyleStr) & ' + TBS_NOTHUMB')
  #ENDIF
  #IF(%ptToolTips)
%ptSliderObject.m_Style = bor(%ptSliderObject.m_Style, TBS_TOOLTIPS)
    #SET(%ptSliderStyleStr, CLIP(%ptSliderStyleStr) & ' + TBS_TOOLTIPS')
  #ENDIF
  #IF(%ptRangeSelection)
%ptSliderObject.m_Style = bor(%ptSliderObject.m_Style, TBS_ENABLESELRANGE)
    #SET(%ptSliderStyleStr, CLIP(%ptSliderStyleStr) & ' + TBS_ENABLESELRANGE')
  #ENDIF
  #IF(%ptSliderOrientation = 'Vertical')
%ptSliderObject.m_Style = bor(%ptSliderObject.m_Style, TBS_VERT)
    #SET(%ptSliderStyleStr, CLIP(%ptSliderStyleStr) & ' + TBS_VERT')
  #ENDIF
  #CASE(%ptThumbPoint)
  #OF('Both')
%ptSliderObject.m_Style = bor(%ptSliderObject.m_Style, TBS_BOTH)
    #SET(%ptSliderStyleStr, CLIP(%ptSliderStyleStr) & ' + TBS_BOTH')
  #OF('Bottom')
%ptSliderObject.m_Style = bor(%ptSliderObject.m_Style, TBS_BOTTOM)
    #SET(%ptSliderStyleStr, CLIP(%ptSliderStyleStr) & ' + TBS_BOTTOM')
  #OF('Left')
%ptSliderObject.m_Style = bor(%ptSliderObject.m_Style, TBS_LEFT)
    #SET(%ptSliderStyleStr, CLIP(%ptSliderStyleStr) & ' + TBS_LEFT')
  #OF('Top')
%ptSliderObject.m_Style = bor(%ptSliderObject.m_Style, TBS_TOP)
    #SET(%ptSliderStyleStr, CLIP(%ptSliderStyleStr) & ' + TBS_TOP')
  #OF('Right')
%ptSliderObject.m_Style = bor(%ptSliderObject.m_Style, TBS_RIGHT)
    #SET(%ptSliderStyleStr, CLIP(%ptSliderStyleStr) & ' + TBS_RIGHT')
  #ENDCASE
#! %ptSliderObject.m_Style = %ptSliderStyleStr
  #CASE(%ptSliderFrame)
  #OF('No Frame')
    #SET(%PtSliderStyleExStr, '0')
  #OF('Static Edge')
    #SET(%PtSliderStyleExStr, 'WS_EX_STATICEDGE')
  #OF('Client Edge')
    #SET(%PtSliderStyleExStr, 'WS_EX_CLIENTEDGE')
  #ENDCASE
%ptSliderObject.m_StyleEx = %PtSliderStyleExStr
  #FIX(%Control, %GetControlName())
!%ptSliderObject.m_ControlID = %ActiveTemplateInstance
if ~%ptSliderObject.CreateTB(%Control, 0{prop:ClientHandle})
  message('Trackbar control cannot be created.')
end
  #IF(NOT %ptSliderPos)
    #ERROR('No Slider position var defined')
  #ELSE
%ptSliderObject.m_SliderPos &= %ptSliderPos

  #ENDIF
  #IF(%ptSliderLowerType = 'Constant')
    #SET(%ptSliderSetLimitLower, %ptSliderLowerConst)
  #ELSE
    #SET(%ptSliderSetLimitLower, %ptSliderLowerVar)
  #ENDIF
  #IF(%ptSliderUpperType = 'Constant')
    #SET(%ptSliderSetLimitUpper, %ptSliderUpperConst)
  #ELSE
    #SET(%ptSliderSetLimitUpper, %ptSliderUpperVar)
  #ENDIF
%ptSliderObject.SetLimit(%ptSliderSetLimitLower, %ptSliderSetLimitUpper)
  #IF(%ptRangeSelection)
    #IF(%ptRangeStartType = 'Constant')
      #SET(%ptSliderSetRangeStart, %ptRangeStartConst)
    #ELSE
      #SET(%ptSliderSetRangeStart, %ptRangeStartVar)
    #ENDIF
    #IF(%ptRangeEndType = 'Constant')
      #SET(%ptSliderSetRangeEnd, %ptRangeEndConst)
    #ELSE
      #SET(%ptSliderSetRangeEnd, %ptRangeEndVar)
    #ENDIF
%ptSliderObject.SetRange(%ptSliderSetRangeStart, %ptSliderSetRangeEnd)
    #IF(%ptThumbInRange)
%ptSliderObject.m_ThumbInRange = true
    #ENDIF
  #ENDIF
  #IF(%ptTickFreq <> 0)
%ptSliderObject.SetTicsFreq(%ptTickFreq)
  #ENDIF
  #IF(%ptSetSliderPosition)
%ptSliderObject.SetPos(%ptSliderPos)
  #ENDIF
#ENDAT

#AT(%cTrackMethodCodeSection, %ActiveTemplateInstance, 'TakeNotification','(),LONG'), PRIORITY(7500)
  #IF(%ptThumbInRange = 1)
if SELF.m_ThumbInRange
  if ~inrange(SELF.m_SliderPos, SELF.GetStart(), SELF.GetEnd())
    SELF.SetPos(choose(SELF.m_SliderPos > SELF.GetEnd(), SELF.GetEnd(), SELF.GetStart()))
    return(false)
  end
end
  #ENDIF
#ENDAT

#GROUP(%GetControlName,%SearchReport=%False),PRESERVE      #!Gets the control name for the current active template
#IF(%Searchreport)
  #FIND(%ReportControlInstance,%ActiveTemplateInstance,%ReportControl)
  #RETURN (%ReportControl)
#ELSE
  #FIND(%ControlInstance,%ActiveTemplateInstance,%Control)
  #RETURN (%Control)
#END


#GROUP(%NoCaseFix,*%Symbol,%FixValue),AUTO
#DECLARE(%i,LONG)
#FIX(%Symbol,%FixValue)
#IF(%Symbol NOT=%FixValue)
  #LOOP,FOR(%i,1,ITEMS(%Symbol))
    #SELECT(%Symbol,%i)
    #IF(UPPER(%Symbol)=UPPER(%FixValue))
      #BREAK
    #ENDIF
  #ENDLOOP
#ENDIF

#GROUP(%BaseClassToUse)
#IF(%UseDefaultABCBaseClass)
  #IF(%ActualDefaultBaseClassType)
    #RETURN(%ActualDefaultBaseClassType)
  #ELSE
    #ASSERT(%DefaultBaseClassType,'%BaseClassToUse: Symbol %DefaultBaseClassType is being returned empty ['&%ClassItem&']')
    #RETURN(%DefaultBaseClassType)
  #ENDIF
#ELSIF(%UseABCBaseClass)
  #RETURN(%ABCBaseClass)
#ELSIF(~%UseABCBaseClass)
  #RETURN(%ExtBaseClass)
#ENDIF
#ASSERT(%False,'%BaseClassToUse: IF clauses all missed')

#GROUP(%MethodEmbedPointValid)
#IF(UPPER(%pClassName)=UPPER(%BaseClassToUse()) AND ~%pClassMethodPrivate)
  #RETURN(%True)
#ENDIF
#RETURN(%False)

#GROUP(%GetEmbedTreeDesc,%EmbedType,%ProcedureSection,%AdditionalLevels=''),AUTO
#DECLARE(%EmbedDesc)
#CASE(UPPER(%EmbedType))
#OF('FILE MANAGER')
#OROF('RELATION MANAGER')
#OROF('ERROR MANAGER')
#OROF('INI MANAGER')
#OROF('TRANSLATOR')
  #SET(%EmbedDesc,'Global Objects|')
#ELSE
  #SET(%EmbedDesc,'Local Objects{{PRIORITY(2000)}|')
#ENDCASE
#IF(%AdditionalLevels)
  #SET(%EmbedDesc,%EmbedDesc&%AdditionalLevels&'|')
#ENDIF
#SET(%EmbedDesc,%EmbedDesc&%GetObjectEmbedDesc(%EmbedType)&'|'&%GetObjectEmbedPrototype())
#CASE(UPPER(%ProcedureSection))
#OF('DATA')
  #SET(%EmbedDesc,%EmbedDesc&'|DATA')
  #IF(%ColorEntriesOnEmbeds)
    #SET(%EmbedDesc,%EmbedDesc&'{{COLOR('&%ColorDataSection&')}')
  #ENDIF
#OF('CODE')
  #SET(%EmbedDesc,%EmbedDesc&'|CODE')
  #IF(%ColorEntriesOnEmbeds)
    #SET(%EmbedDesc,%EmbedDesc&'{{COLOR('&%ColorCodeSection&'),PRIORITY(5000)}')
  #ELSE
    #SET(%EmbedDesc,%EmbedDesc&'{{PRIORITY(5000)}')
  #ENDIF
#ELSE
  #ASSERT(%False,'%GetEmbedTreeDesc: Unknown ProcedureSection')
#ENDCASE
#RETURN(%EmbedDesc)

#GROUP(%GetObjectEmbedDesc,%EmbedType),AUTO
#DECLARE(%RVal)
#IF(%ShowBaseClassOnEmbeds)
  #CASE(UPPER(%EmbedType))
  #OF('FILE MANAGER')
    #SET(%RVal,%ThisObjectName&'  ('&%CacheFileManager&')')
  #OF('RELATION MANAGER')
    #SET(%RVal,%ThisObjectName&'  ('&%CacheRelationManager&')')
  #OF('ERROR MANAGER')
    #SET(%RVal,'GlobalErrors  ('&%ErrorManagerType&')')
  #OF('INI MANAGER')
    #SET(%RVal,'INIMgr  ('&%INIClass&')')
  #OF('TRANSLATOR')
    #SET(%RVal,'Translator  ('&%RunTimeTranslatorType&')')
  #ELSE
    #SET(%RVal,%ThisObjectName&'  ('&%BaseClassToUse()&')')
  #ENDCASE
#ENDIF
#IF(%ShowDescriptionOnEmbeds)
  #CASE(UPPER(%EmbedType))
  #OF('FILE MANAGER')
    #SET(%RVal,%RVal&'  File Manager for '&%File)
  #OF('RELATION MANAGER')
    #SET(%RVal,%RVal&'  Relation Manager for '&%File)
  #OF('ERROR MANAGER')
    #SET(%RVal,%Rval&'  Global Error Manager')
  #OF('INI MANAGER')
    #SET(%RVal,%RVal&'  Global INI Manager')
  #OF('TRANSLATOR')
    #SET(%RVal,%RVal&'  Global Run-Time Translator')
  #OF('DEFAULT BROWSE LOCATOR')
    #SET(%RVal,%RVal&'  Default Locator for '&%ActiveTemplateInstanceDescription)
  #OF('BROWSE LOCATOR')
    #SET(%RVal,%RVal&'  Conditional Locator for '&%ActiveTemplateInstanceDescription)
  #OF('DEFAULT BROWSE STEP')
    #SET(%RVal,%RVal&'  Default Step Manager for '&%ActiveTemplateInstanceDescription)
  #OF('BROWSE STEP')
    #SET(%RVal,%RVal&'  Conditional Step Manager for '&%ActiveTemplateInstanceDescription)
  #OF('EDIT IN PLACE')
    #SET(%RVal,%RVal&'  Edit-in-Place Manager')
  #OF('TOOLBAR MANAGER')
    #SET(%RVal,%RVal&'  Toolbar Manager')
  #OF('WINDOW MANAGER')
    #SET(%RVal,%RVal&'  Window Manager')
  #OF('BROWSE EIP MANAGER')
    #SET(%RVal, %RVal & ' Browse EIP Manager for ' & %ActiveTemplateInstanceDescription)
  #ELSE
    #SET(%Rval,%Rval&'  '&%ActiveTemplateInstanceDescription)
  #ENDCASE
#ENDIF
#IF(%ShowDetailsOnEmbeds)
  #CASE(UPPER(%EmbedType))
  #OF('BROWSE LOCATOR')
    #SET(%RVal,%RVal&'  [Condition: '&%SortCondition&']')
  #OF('BROWSE STEP')
    #SET(%RVal,%RVal&'  [Condition: '&%SortCondition&']')
  #OF('EDIT IN PLACE')
    #SET(%RVal,%RVal&'  [Field: '&%EditInPlaceField&']')
  #ENDCASE
#ENDIF
#ASSERT(%RVal,'%GetObjectEmbedDesc: Description being returned blank')
#RETURN(CLIP(LEFT(%RVal)))
#!
#!
#GROUP(%GetObjectEmbedPrototype),AUTO
#EQUATE(%RVal,%pClassMethod)
#IF(%ShowPROCEDUREonEmbeds)
  #SET(%RVal,%RVal&' PROCEDURE')
#ENDIF
#IF(%pClassMethodPrototype<>'()')
  #SET(%RVal,%RVal&%pClassMethodPrototype)
#ENDIF
#IF(%ShowVIRTUALonEmbeds AND %pClassMethodVirtual)
  #SET(%RVal,%RVal&',VIRTUAL')
#ENDIF
#IF(%ShowPROTECTEDonEmbeds AND %pClassMethodProtected)
  #SET(%RVal,%RVal&',PROTECTED')
#ENDIF
#IF(%ColorEntriesOnEmbeds)
  #IF(%pClassMethodVirtual)
    #SET(%RVal,%RVal&'{{COLOR('&%ColorVirtualMethod&')}')
  #ELSIF(%pClassMethodProtected)
    #SET(%RVal,%RVal&'{{COLOR('&%ColorProtectedMethod&')}')
  #ENDIF
#ENDIF
#RETURN(%RVal)
#!
#!

#GROUP(%ParentCallValid)
#IF(UPPER(%pClassMethod)='CONSTRUCT' OR UPPER(%pClassMethod)='DESTRUCT' OR %pClassMethod='')
  #RETURN(%False)
#ENDIF
#RETURN(%True)